var multipart_boundary = new Date().getTime() 

function openLocalFile(){
		var nsIFilePicker = Components.classes["@mozilla.org/filepicker;1"].createInstance(Components.interfaces.nsIFilePicker);
		nsIFilePicker.init(window, "upload image file", Components.interfaces.nsIFilePicker.modeOpen);
		nsIFilePicker.appendFilter("all images", "*.*");
		if (nsIFilePicker.show() == Components.interfaces.nsIFilePicker.returnOK)
		{
			document.getElementById('file_name').value=nsIFilePicker.file.leafName
			document.getElementById('file_name').fileObject=nsIFilePicker.file
		}
}
//function uploadFile(nsIFile_file)
function uploadFile(nsIFile_file)
{
	logString(nsIFile_file.leafName.split(".").pop().toLowerCase())

	const boundaryString = new Date().getTime()

	var outputStream = createStream(
		{
			file_name: nsIFile_file.leafName,
			file_data: nsIFile_file
		},
		boundaryString
	)
	
	if(outputStream){
		var XMLHttpRequest_upload = new XMLHttpRequest();
		
		XMLHttpRequest_upload.onerror = function() { logString("sux0rz") }
		
		XMLHttpRequest_upload.onload = function() { logString("rox0rz") }
		
		XMLHttpRequest_upload.open("POST", "url", true, "login", "pass");
		XMLHttpRequest_upload.setRequestHeader("Content-Type", "multipart/form-data; boundary=---------------------------" + boundaryString);
		XMLHttpRequest_upload.send(outputStream);
	}
}

function logString(str){
	document.getElementById('log').value+=str+"\n"
}



function createStream(postData, boundaryString){
	//create the main stream
	var nsIMultiplexInputStream = Components
	.classes["@mozilla.org/io/multiplex-input-stream;1"]
	.createInstance(Components.interfaces.nsIMultiplexInputStream)

	for (var postItem in postData){
		//create a text stream
		var nsIStringInputStream = Components
			.classes["@mozilla.org/io/string-input-stream;1"]
			.createInstance(Components.interfaces.nsIStringInputStream)
			
		//alert('postItem: '+typeof(postData[postItem])+' '+postData[postItem])
			
		//hack - if it is a file object, it does have this function, and this request won't raise an error
		if(typeof(postData[postItem])=="string"){
			alert("\r\n-----------------------------" + boundaryString + "\r\nContent-Disposition: form-data; name=\"" + postItem + "\"\r\n\r\n" + postData[postItem])
			nsIStringInputStream.setData("\r\n-----------------------------" + boundaryString + "\r\nContent-Disposition: form-data; name=\"" + postItem + "\"\r\n\r\n" + postData[postItem], -1)
			nsIMultiplexInputStream.appendStream(nsIStringInputStream)
		}else{
			// toto neviem ci bue treba vobec, ak ano, tak to treba pridat
			//Content-Type: image\r\n
			nsIStringInputStream.setData("\r\n-----------------------------" + boundaryString + "\r\nContent-Disposition: form-data; name=\"" + postItem + "\"; filename=\"" + postItem.leafName + "\"\r\n\r\n", -1)
			
			nsIMultiplexInputStream.appendStream(nsIStringInputStream)
			
			//create a binary stream
			var nsIFileInputStream = Components
				.classes["@mozilla.org/network/file-input-stream;1"]
				.createInstance(Components.interfaces.nsIFileInputStream)
			nsIFileInputStream.init(postData[postItem], 1, 1, Components.interfaces.nsIFileInputStream.CLOSE_ON_EOF)
			var nsIBufferedInputStream = Components
				.classes["@mozilla.org/network/buffered-input-stream;1"]
				.createInstance(Components.interfaces.nsIBufferedInputStream)
			nsIBufferedInputStream.init(nsIFileInputStream, 4096)
			
			nsIMultiplexInputStream.appendStream(nsIBufferedInputStream)
		}
	}

	var nsIStringInputStream_end = Components
		.classes["@mozilla.org/io/string-input-stream;1"]
		.createInstance(Components.interfaces.nsIStringInputStream)
	nsIStringInputStream_end.setData(
		"\r\n" + "-----------------------------" + boundaryString + "--\r\n",
		-1
	)
	nsIMultiplexInputStream.appendStream(nsIStringInputStream_end)
	return nsIMultiplexInputStream 
}



function getStreamData(file_name)
{
	return "\r\n-----------------------------" + multipart_boundary + "\r\nContent-Disposition: form-data; name=\"file_name\"\r\n\r\n" + file_name + "\r\n-----------------------------" + multipart_boundary + "\r\nContent-Disposition: form-data; name=\"file_extension\"\r\n\r\n" + file_name.split(".").pop().toLowerCase() + "\r\n-----------------------------" + multipart_boundary + "\r\nContent-Disposition: form-data; name=\"file_data\"; filename=\"" + file_name + "\"\r\nContent-Type: image\r\n\r\n"
	//+ "\r\nContent-Disposition: form-data; name=\"action\"\r\n\r\naddpic\r\n-----------------------------" + multipart_boundary
	//+ (this.preserve_names ? "\r\nContent-Disposition: form-data; name=\"preserve\"\r\n\r\ntrue\r\n-----------------------------" + multipart_boundary : "")
	//+ (this.use_description ? "\r\nContent-Disposition: form-data; name=\"desc[]\"\r\n\r\n" + prompt("Enter description for " + file_name) + "\r\n-----------------------------" + multipart_boundary : "")
}
