// *********************************************
// Core
// *********************************************

var cs_Core =
{
	servertime: 0,
	domain_url : null,
	my_domain_url : null,
	key_file : null,
	header :
	{
		title : "Cyclone3 XULadmin Core",
		version : "1.2"
	},

	config:
	{
		//storage array of id=bool for initialized windows
		initializedWindows : null,
		host : null,
		loggateway : null,
		lng : "",
		lngDefault : "",
		lngs : [],

		// Initialized by type=conf_list
		lang: new Array(),
		apps: new Array(),
		modules: new Array(),
		custom: new Array(),

		USRM: {}
	},

	usrm :
	{
		login : null,
		logged : false
	},

/*
			if (typeof(InstallTrigger) != 'undefined')
			{
				var ExtensionManager = Components.classes["@mozilla.org/extensions/manager;1"].getService(Components.interfaces.nsIExtensionManager)
				var ext = null
				if (ExtensionManager.getItemForID){
					ext = ExtensionManager.getItemForID('{FAA9C47E-3397-4fc9-8C0E-7314E3A0AA66}')
				}else{
					ext = ExtensionManager.getItemList('{FAA9C47E-3397-4fc9-8C0E-7314E3A0AA66}', null, {})[0]
				}

				alert('my extension version:'+ext.version)

				var hua = InstallTrigger.getVersion('cyclone')
				alert(hua)
				var xpi = {
					'Cyclone CMS':{
						URL: 'http://www.mozilla.org',
						IconURL: "chrome://cyclone/skin/icon.png"
					}
				}

				//var xpi = {'Cyclone CMS': 'http://www.webcom.sk/cyclone.xpi'}
				InstallTrigger.install(xpi)
			}

				Handler.fnc_create(
					{
						gateway: document.getElementById("content-folders-a500"),
						replaceMode: "treechildren"
					},
					"",
					{
						type: "a500_tree",
						lng: cs_Core.config.lng
					}
				)
		}

	},
*/
	locale :
	{
		get : function()
		{
			//Handler.fnc_create({}, "", { type: "locale_string_list" })
			var tmpBundle = ui.toolbox.stringBundle.get("chrome://cyclone/locale/stringlist.properties")
			
			if(tmpBundle)
			{
				cs_Core.locale.stringBundle=tmpBundle
			}
			else
			{
				alert('could not load interface language for your locale!')
			}
		},
		
		getStringFromName : function (stringName)
		{
			try
			{
				return cs_Core.locale.stringBundle.GetStringFromName(stringName)
			}
			catch(e)
			{
				/*alert("Could not get localized string for '"+stringName+"'\n"+e)*/
				return stringName
			}
			return ""
		},
		
		formatStringFromName : function (stringName, parametersArray, parametersLength)
		{
			try
			{
				return cs_Core.locale.stringBundle.formatStringFromName(stringName, parametersArray, parametersLength)
			}
			catch(e)
			{
				alert(e)
			}
			return ""
		},
		
		parse : function(e4x)
		{
			for each(var item in e4x.item)
			{
				cs_Core.locale.strings[item.@IDitem]=item
			}
		},
		
		strings : null
/*
		strings :
		[
		]
*/
	},
	log :
	{
		append : function (logText)
		{
			
			var aConsoleService = Components.classes["@mozilla.org/consoleservice;1"].
				getService(Components.interfaces.nsIConsoleService);
			aConsoleService.logStringMessage(logText);
			/*
			
			if (!cs_Core.config.loggateway) return
			var listBoxItem=document.createElement('treeitem');
			var listBoxRow=document.createElement('treerow');

			var now = new Date();
			var hour        = now.getHours();
			var minute      = now.getMinutes();
			var second      = now.getSeconds();
			var monthnumber = now.getMonth()+1;
			var monthday    = now.getDate();
			var year        = now.getYear()+1900;

			if(monthnumber<10){monthnumber="0"+monthnumber;}
			if(monthday<10){monthday="0"+monthday;}
			if(hour<10){hour="0"+String(hour);}
			if(minute<10){minute="0"+String(minute);}
			if(second<10){second="0"+String(second);}

			listBoxRow.appendChild( document.createElement('treecell') ).setAttribute('label', year+"-"+monthnumber+"-"+monthday+" "+hour+"-"+minute+"-"+second);
			listBoxRow.appendChild( document.createElement('treecell') ).setAttribute('label', logText);
			listBoxItem.appendChild(listBoxRow);
			cs_Core.config.loggateway.appendChild(listBoxItem);
			*/
		}
	}
}

var Apps = {}

var ui = {}
