var var_globalRequestOrdinal=0
var var_globalRequestCount=0
var arr_globalRequestPoll = new Array()

var Handler = new AjaxHandler()

Handler.var_ident = "category-picker"

Handler.arr_requestPoll=arr_globalRequestPoll
Handler.var_ordinal=var_globalRequestOrdinal
Handler.var_count=var_globalRequestCount

var lastRequest

Handler.reload = function(xulNode, argumentsTweak){
	var tmpIDrequest
	if(xulNode.nodeName){
		if(xulNode.hasAttribute('IDrequest')){
			tmpIDrequest = xulNode.getAttribute('IDrequest')
		}
	}else if(parseInt(xulNode)==xulNode){
		tmpIDrequest=xulNode
	}

	if(tmpIDrequest){
		log('Reloading request #'+tmpIDrequest+' ...')

		if(this.arr_requestPoll[tmpIDrequest]){
			var tmpRequestSetup = this.arr_requestPoll[tmpIDrequest].setup

			for (var tmpArg in argumentsTweak){
				this.arr_requestPoll[tmpIDrequest].args[tmpArg] = argumentsTweak[tmpArg]
			}

			Handler.fnc_create(
				this.arr_requestPoll[tmpIDrequest].setup,
				this.arr_requestPoll[tmpIDrequest].url,
				this.arr_requestPoll[tmpIDrequest].args
			)
		}
	}else{
		log('Could not refresh content for '+xulNode)
	}
}

Handler.fnc_onLoad = function(dataObject){
try{
	var e4x = dataObject.e4x
	var id = dataObject.IDRequest
	
	if ( e4x.@result == 0){
		alert(e4x.reason)
	}
	
	if (e4x.@type == "tree"){
		document.getElementById('contentStructure').fnc_dataAppend(e4x)
	}
	
	if (e4x.@type == "list"){
		fnc_attachList(e4x, id)
	}
}catch(e){
	alert(e)
}
}

function fnc_windowInit()
{
	try
	{
		
		cs_Core=window.opener.cs_Core
		
		window.outerWidth=720
		window.outerHeight=400
		var mvX=((window.screen.availWidth-window.outerWidth)/2)
		var mvY=((window.screen.availHeight-window.outerHeight)/2)
		window.moveTo(mvX, mvY)
		
		var tmpLng = window.arguments[0].lng
		
		document.getElementById('content-lng').value = tmpLng
		
		for each (var tmpIPApp in window.arguments[0].IDapps)
		{
			
			document.getElementById('contentStructure').fnc_dataAppendApp(tmpIPApp)
			
			var tmpType = tmpIPApp + "_tree"
			
			Handler.fnc_create(
					{
					},
					"",
					{
						type: tmpType,
						lng: tmpLng
					}
				)
		}
		
		var tmpType = window.arguments[0].IDapps[0] + "_list"
		
		Handler.fnc_create(
				{
					gateway: document.getElementById("content-list")
				},
				"",
				{
					type: tmpType,
					lng: tmpLng
				}
		)
			
		document.getElementById('content-folders').setAttribute('IDapp',window.arguments[0].IDapps[0])
	
	}catch(e){alert(e)}
}

function fnc_OK(){
	try{
	
	
		var tmpColPrefix=document.getElementById('content-folders').getAttribute('IDapp')+"_list_col-"
		
		var tmpID, tmpIDapp
		
		var listXulNode=document.getElementById('content-tab-list').nod_contentObject

		var selCount = listXulNode.view.selection.getRangeCount();

		for (var i=0; i<selCount; i++)
		{
			var start = new Object();
			var end = new Object();

			listXulNode.view.selection.getRangeAt(i,start,end);
			for (var j=start.value; j<=end.value; j++)
			{
				tmpIDapp = document.getElementById('content-folders').getAttribute('IDapp')
				tmpID = listXulNode.view.getCellValue(j, listXulNode.treeBoxObject.columns.getNamedColumn(tmpColPrefix+"ID"))
				if(tmpIDapp == 'a540')
					tmpName = listXulNode.view.getCellValue(j, listXulNode.treeBoxObject.columns.getNamedColumn(tmpColPrefix+"name"))	
				else
					tmpName = listXulNode.view.getCellValue(j, listXulNode.treeBoxObject.columns.getNamedColumn(tmpColPrefix+"title"))	
			}
		}
		
		window.arguments[0].returnFunction(
			{
				ID: tmpID,
				name: tmpName, 
				IDapp: tmpIDapp
			}
		)
		window.close()
	}catch(e){alert(e)}
}

function fnc_contentStructure_onMouseDown(event){
	try{
		var xulNode = document.getElementById('contentStructure')
		var row = {}, col = {}, obj = {}
		xulNode.treeBoxObject.getCellAt(event.clientX, event.clientY, row, col, obj)
	
		row=row.value
		col=col.value
		obj=obj.value
	
		if(row>-1){
		  if(obj == ''){
	      return
	    }
			if(obj!='twisty'){
			   if(event.button==0){
			   	var cell_value = xulNode.view.getCellValue(row, col)
			      //left button clicked
			      
			    document.getElementById('content-folders').setAttribute('IDapp',xulNode.view.getCellValue(row, {id: 'IDapp'}))
	
					Handler.fnc_create(
						{
							gateway: document.getElementById('content-list')
						},
						"",
						{
							type: xulNode.view.getCellValue(row, {id: 'IDapp'})+"_list",
							IDcategory: xulNode.view.getCellValue(row, {id: 'ID'}),
							lng: document.getElementById('content-lng').value
						}
					)
				}
			}
		}
	}catch(e){alert(e)}
}

fnc_attachList = function (e4x, IDrequest)
{
try{

	var tmpTimestamp=new Date().getTime()

	var newNode

	if(
		(arr_globalRequestPoll[IDrequest].setup.gateway==document.getElementById('content-list'))
		||(!arr_globalRequestPoll[IDrequest].setup.gateway)
	)
	{
	   if(
			document.getElementById('content-tab-list').prop_IDapp!=e4x.@IDapp
		)
	   {
			//panel nema IDapp, alebo nie je panelom listingu ankiet, takze ho zamenime
			var tmpTimestamp=new Date().getTime()
			var tmpPanel=document.createElement('tabpanel')
			tmpPanel.setAttribute('id', 'panel-'+tmpTimestamp)

			document.getElementById('content-tab-list').parentNode.replaceChild(tmpPanel, document.getElementById('content-tab-list'))
			tmpPanel=document.getElementById('panel-'+tmpTimestamp)
			tmpPanel.setAttribute('id', 'content-tab-list')
			tmpPanel.setAttribute('class', e4x.@IDapp+'_list-tiny') 
			newNode=tmpPanel
		}else{
			//displayed panel is already an tmpIDapp panel, so we just reuse the content element
			newNode=document.getElementById('content-tab-list')
		}
	   var intervalID = window.setInterval(
			function(){
				if(document.getElementById('content-tab-list').fnc_init){
					document.getElementById('content-tab-list').fnc_init(e4x, IDrequest)
					window.clearInterval(intervalID)
				}
			},
			100
		)
	}
	else
	{
		var tmpXulObject = ui[this.id].list(e4x,IDrequest)

		if(typeof(tmpXulObject)=="object"){
			tmpXulObject.setAttribute('id',tmpTimestamp)
			tmpXulObject.setAttribute('IDrequest', IDrequest)

			if(arr_globalRequestPoll[IDrequest].setup.replaceMode=='direct'){
				//budeme replacovat gateway samotny
				if(arr_globalRequestPoll[IDrequest].setup.gateway){
					//mame specifikovany konkretny gateway
					var oldId;
					if(arr_globalRequestPoll[IDrequest].setup.gateway.getAttribute('id')){
						//backup id-cka gateway objektu, ktory ideme replacnut - budeme ho potrebovat, aby sme sa nan mohli v buducnosti odkazat
						oldId = arr_globalRequestPoll[IDrequest].setup.gateway.getAttribute('id')
					}
					var oldIdData;
					if(arr_globalRequestPoll[IDrequest].setup.gateway.getAttribute('IDdata')){
						//backup iddata
						oldIdData = arr_globalRequestPoll[IDrequest].setup.gateway.getAttribute('IDdata')
					}
					var oldIdAnon;
					if(arr_globalRequestPoll[IDrequest].setup.gateway.getAttribute('IDanon')){
						//backup idanon
						oldIdAnon = arr_globalRequestPoll[IDrequest].setup.gateway.getAttribute('IDanon')
					}

					var oldIDtoolbar;
					if(arr_globalRequestPoll[IDrequest].setup.gateway.getAttribute('IDtoolbar')){
						//backup id-cka IDtoolbar objektu, ktory ideme replacnut - budeme ho potrebovat, aby sme sa nan mohli v buducnosti odkazat
						oldIDtoolbar = arr_globalRequestPoll[IDrequest].setup.gateway.getAttribute('IDtoolbar')
					}

					var replacedNode = arr_globalRequestPoll[IDrequest].setup.gateway.parentNode.replaceChild(tmpXulObject, arr_globalRequestPoll[IDrequest].setup.gateway)

					newNode = document.getElementById(tmpTimestamp)

					if(oldId){
						newNode.setAttribute('id',oldId)
					}else{
						newNode.removeAttribute('id')
					}

					if(oldIdData){
						newNode.setAttribute('IDdata',oldIdData)
					}

					if(oldIdAnon){
						newNode.setAttribute('IDanon',oldIdAnon)
					}

					//fixujeme referencie na stary objekt - presmerovanim na novy
					for each(var tmpSetup in arr_globalRequestPoll){
						if(tmpSetup.setup){
							if(tmpSetup.setup.gateway==replacedNode){
								tmpSetup.setup.gateway=newNode
							}
						}
					}

					if(oldIDtoolbar){
						newNode.setAttribute('IDtoolbar',oldIDtoolbar)
					}

					//arr_globalRequestPoll[IDrequest].setup.gateway=newNode
				}else{
					arr_globalRequestPoll[IDrequest].setup.gateway = document.getElementById('content-list')
					arr_globalRequestPoll[IDrequest].setup.gateway.parentNode.replaceChild(tmpXulObject, arr_globalRequestPoll[IDrequest].setup.gateway)
					arr_globalRequestPoll[IDrequest].setup.gateway = document.getElementById('content-list')
				}
				//var newNode = document.getElementById(tmpTimestamp)
			}else if(arr_globalRequestPoll[IDrequest].setup.replaceMode=='treechildren'){
				if(!arr_globalRequestPoll[IDrequest].setup.gateway){
					arr_globalRequestPoll[IDrequest].setup.gateway = document.getElementById('content-list')
				}

				while(arr_globalRequestPoll[IDrequest].setup.gateway.getElementsByTagName('treechildren')[0].firstChild){
					arr_globalRequestPoll[IDrequest].setup.gateway.removeChild(arr_globalRequestPoll[IDrequest].setup.gateway.getElementsByTagName('treechildren')[0].firstChild)
				}
				while(tmpXulObject.getElementsByTagName('treechildren')[0].childNodes.length){
					arr_globalRequestPoll[IDrequest].setup.gateway.getElementsByTagName('treechildren')[0].appendChild(tmpXulObject.getElementsByTagName('treechildren')[0].childNodes[0])
				}

			}
		}

		newNode = arr_globalRequestPoll[IDrequest].setup.gateway

		//setting IDrequest attribute (can be retrieved later, to consistently redo the same, or slightly changed request again without doing the whole setup thingy again)
		newNode.setAttribute('IDrequest', IDrequest)

		//log('newNode.nodeName='+newNode.nodeName)

		switch (newNode.nodeName){
			case 'tree':
				//log('do we have selectedItems for tree?')
				//check treeitems
				if(arr_globalRequestPoll[IDrequest].setup.selectedItems){
					//log('we have selecedItems for this tree')
					var i;
					for(i=0;i<arr_globalRequestPoll[IDrequest].setup.selectedItems.length;i++){
						var tmpTreeItems=newNode.getElementsByTagName('treeitem')
						//log('treeitem element count: '+tmpTreeItems.length)
						for(var j=0;j<tmpMenuItems.length;j++){
							if(arr_globalRequestPoll[IDrequest].setup.selectedItems[i]==tmpTreeItems[j].getAttribute('IDitem')){
								newNode.view.toggleSelect(j)
								//log('selecting item on row '+j+' which has IDitem value of '+tmpTreeItems[j].getAttribute('IDitem'))
							}
						}
					}
				}
				break
			case 'listbox':
				//check listitems
				break
			case 'menulist':
				if(arr_globalRequestPoll[IDrequest].setup.selectedItems){
					if(arr_globalRequestPoll[IDrequest].setup.selectedItems.length){
						var i;
						for(i=0;i<arr_globalRequestPoll[IDrequest].setup.selectedItems.length;i++){
							//log('checking list for value of '+arr_globalRequestPoll[IDrequest].setup.selectedItems[i])
							var tmpMenuItems=newNode.getElementsByTagName('menuitem')
							for(var j=0;j<tmpMenuItems.length;j++){
								//log('list item '+j+' has value of '+tmpMenuItems[j].getAttribute('IDitem'))
								if(arr_globalRequestPoll[IDrequest].setup.selectedItems[i]==tmpMenuItems[j].getAttribute('IDitem')){
									//log('newNode '+newNode.nodeName)
									//log('setting selection to '+j)
									newNode.selectedIndex=j;
									break
								}
							}
						}
					}
				}
				break
		}

		if(newNode.getAttribute('IDtoolbar')){
			//node has a toolbar associated, updating
			var tmpToolbar = document.getElementById(newNode.getAttribute('IDtoolbar'))
			if(tmpToolbar){
				if(e4x.setup){
					if(e4x.setup.page){
						var tmpPageCurrent = ui.toolbox.anonymous.getElementByAttribute(tmpToolbar, 'IDanon', "pageCurrent", null)
						if(tmpPageCurrent){
							tmpPageCurrent.value=e4x.setup.page.@current
						}
						var tmpPagePrevious = ui.toolbox.anonymous.getElementByAttribute(tmpToolbar, 'IDanon', "pagePrevious", null)
						if(tmpPagePrevious){
							//alert('prev '+e4x.setup.page.@previous)
							if(e4x.setup.page.@previous>0){
								tmpPagePrevious.removeAttribute('disabled')
							}else{
								tmpPagePrevious.setAttribute('disabled', "true")
							}
						}
						var tmpPageNext = ui.toolbox.anonymous.getElementByAttribute(tmpToolbar, 'IDanon', "pageNext", null)
						if(tmpPageNext){
							//alert('next '+e4x.setup.page.@next)
							if(e4x.setup.page.@next>0){
								tmpPageNext.removeAttribute('disabled')
							}else{
								tmpPageNext.setAttribute('disabled', "true")
							}
						}
					}
				}
			}
		}
	}
	
}catch(e){alert(e)}
}
