ui.toolbox={

	data : {
		winwin : {

		}
	},

	style : {

		classAdd : function (xulNode, className){
			if(className){
				var tmpClasses = xulNode.getAttribute('class').split()
				var classNotFound = true

				var i=0
				while (i < tmpClasses.length){
					if (tmpClasses[i] == className){
						classNotFound = false
						break
					} else {
						i++
					}
				}
				if(classNotFound){
					tmpClasses.push(className)
					xulNode.setAttribute('class', tmpClasses.join(' '))
				}else{
					log('class \'' + tmpClasses + '\' already set')
				}
				log('set class to: '+tmpClasses.join(' '))
			}
		},

		classRemove : function (xulNode, className){
			if((xulNode.getAttribute('class')) && (className)){
				var tmpClasses = xulNode.getAttribute('class').split()

				var i=0
				while (i < tmpClasses.length){
					if (tmpClasses[i] == className){
						tmpClasses.splice(i, 1)
					} else {
						i++
					}
				}
				xulNode.setAttribute('class', tmpClasses.join(' '))
				log('unset class to: '+tmpClasses.join(' '))
			}
		}

	},

	checks : {
		isArray : function (obj) {
			if(obj){
				//returns true is it is an array
				if (obj.constructor.toString().indexOf('Array') == -1){
					return false
				}else{
					return true
				}
			}else{
				return false
			}
		}
	},

	anonymous : {
		getElementByAttribute : function (elRoot, elAttribute, elValue, processDepth)
		{
			processDepth++
			if (elRoot)
			{
				//log(processDepth+"root is "+elRoot.nodeName)
				if(elRoot.childNodes.length){
					//log(processDepth+"  root has "+elRoot.childNodes.length+" childrensies")
					for(var i=0;i<elRoot.childNodes.length;i++){
						var currentChild=elRoot.childNodes[i];

						//log(processDepth+"    examiningingo childrenzo "+i+" ("+currentChild.nodeName+") childnodes.length: "+currentChild.childNodes.length)
						//log(processDepth+"    child iteration "+(i+1)+"/"+elRoot.childNodes.length+" ("+currentChild.nodeName+") childnodes.length: "+currentChild.childNodes.length)

						//najprv si zistime ci currentChild nahodou nie je nas clovek, aby sme neplytvali resourcami :)
						if(currentChild.getAttribute(elAttribute)){
							if(currentChild.getAttribute(elAttribute)==elValue){
								//log(processDepth+"      "+currentChild.nodeName+" - success!!! "+elAttribute+": "+currentChild.getAttribute(elAttribute))
								return currentChild
							}else{
								//log(processDepth+"      "+currentChild.nodeName+" - failure!!! "+elAttribute+": "+currentChild.getAttribute(elAttribute))
							}
						}else{
							//log(processDepth+"      "+currentChild.nodeName+" - we don't have the '"+elAttribute+"' attribute!")
						}

						//ak ma currentChild deturence, prenechame search subprocesu
						if(currentChild.childNodes.length)
						{
							var tmpReturn=ui.toolbox.anonymous.getElementByAttribute(currentChild,elAttribute,elValue,processDepth)
							if (tmpReturn){
								//log(processDepth+"      we have a return from subprocess "+(processDepth+1)+" ("+tmpReturn.nodeName+")")
								return tmpReturn
							}
							else{
								//log(processDepth+"      we didn't get SHIT from subprocess "+(processDepth+1))
								continue
							}
						}else{
							continue
						}
					}
				}
			}
			return null
		},

		getElementsWithAttribute : function (elRoot, elAttribute, objectPoll, processDepth)
		{
			if(!objectPoll){
				//log("pregenerating objectPoll")
				objectPoll=new Array()
			}
			processDepth++
			if (elRoot)
			{
				if(elRoot.childNodes.length){
					for(var i=0;i<elRoot.childNodes.length;i++){
						var currentChild=elRoot.childNodes[i];

						if(currentChild.hasAttribute(elAttribute)){
							//alert("we have "+currentChild.getAttribute(elAttribute))
							objectPoll.push(currentChild)
						}

						//ak ma currentChild deturence, prenechame search subprocesu
						if(currentChild.childNodes.length)
						{
							var tmpReturn=ui.toolbox.anonymous.getElementsWithAttribute(currentChild, elAttribute, objectPoll, processDepth)
							objectPoll=tmpReturn
						}else{
							continue
						}
					}
				}
			}
			return objectPoll
		},

		getIDapp : function (xulNode, maxParent){
			var IDapp=xulNode.getAttribute('IDapp')
			if(!IDapp){
				//element nema appid, skusime sa vybublinkovat az k najparentovskejsiemu nodu

				if(xulNode!=maxParent){
					//node is not identical to maxparent

					var tmpParent=xulNode.parentNode

					if(tmpParent){
						while(!IDapp){
							if(tmpParent.hasAttribute('IDapp')){
								IDapp=tmpParent.getAttribute('IDapp')
							}
							if(tmpParent==maxParent){
								//najparentovskejsi parento, koncime, nevladzeme viac
								break
							}
							tmpParent=tmpParent.parentNode
						}
					}
				}

				if(!IDapp){
					log("the item '"+tmpSelection[i].getAttribute('IDitem')+"', nor his parents do not have IDapp defined!!!")
					return null
				}
			}
			return IDapp
		},

		selection : {
			get : function(xulObject) {
				var tmpTagName=xulObject.tagName.toString()
				tmpTagName.replace(/^xul:/, '')
				switch(tmpTagName){
					case "tree":
						return ui.toolbox.tree.selection.get(xulObject)
						break
					case "listbox":
						return ui.toolbox.listbox.selection.get(xulObject)
						break
					case "textbox":
						return ui.toolbox.textbox.selection.get(xulObject)
						break
					default:
						alert("no selection getter defined for element type "+xulObject.tagName)
				}
				return null
			}
		},

		save : function(xulNode){
			//alert(xulNode.nodeName)
			//alert("node's IDapp "+xulNode.getAttribute('IDapp'))

			//alert(xulNode.fileHandles)

			ui[xulNode.getAttribute('IDapp')].save(xulNode)
		},

		saveandclose : function(xulNode){
			//alert(xulNode.nodeName)
			//alert("node's IDapp "+xulNode.getAttribute('IDapp'))
			ui[xulNode.getAttribute('IDapp')].saveandclose(xulNode)
		},

		children : {
			switchCollapse : function (parentXulNode, IDitem){
				if(parentXulNode){
					//log('switching collapse for parent node '+parentXulNode.nodeName+' with '+parentXulNode.childNodes.length+' childnodes')
					for (var i=0;i<parentXulNode.childNodes.length;i++){
						parentXulNode.childNodes[i].setAttribute('collapsed', 'true')
						//log(parentXulNode.childNodes[i].getAttribute('IDitem')+' node collapsed')
					}
					for (var i=0;i<parentXulNode.childNodes.length;i++){
						//log('checking '+parentXulNode.childNodes[i].getAttribute('IDitem')+' against '+IDitem)
						if(parentXulNode.childNodes[i].getAttribute('IDitem')==IDitem){
							//log(parentXulNode.childNodes[i].getAttribute('IDitem')+' node decollapsed')
							parentXulNode.childNodes[i].setAttribute('collapsed', 'false')
							break
						}
					}
					return true
				}else{
					return null
				}
			}
		},

		getTemplate: function(xulNode, tag, properties) {
			var tmpItems=xulNode.getElementsByTagName(tag)

			for (var j=0; j<tmpItems.length; j++){
				var success=true
				for ( prop in properties ) {
					if(tmpItems[j].hasAttribute(prop)){
						if(tmpItems[j].getAttribute(prop)!=properties[prop]){
							success=false
							break
						}
					}else{
						success=false
						break
					}
				}
				if(success){
					return tmpItems[j]
				}
			}
			return null
		},

		datePicker: {
			setDateTime: function(xulNode, valueId, timestamp){
				var tmpTimestampDestination = ui.toolbox.anonymous.getElementByAttribute(xulNode,'IDdata', valueId, null)
				if(tmpTimestampDestination){
					tmpTimestampDestination.value =  timestamp
					}
					
				var tmpFormattedDestination = ui.toolbox.anonymous.getElementByAttribute(xulNode,'IDanon', valueId, null)
				if(tmpFormattedDestination){
					if(timestamp>0){
						var theDate = new Date(timestamp * 1000);
						dateString = theDate.toGMTString();
						dateString = dateString.replace(/GMT/,'')
					}else{
						dateString = "";
					}
					tmpFormattedDestination.value = dateString
				}
			},

			setDateTime2: function(xulNodeTimestamp, xulNodeFormatted, timestamp){
				if(xulNodeTimestamp){
					xulNodeTimestamp.setAttribute('value', timestamp)
				}
				if(xulNodeFormatted){
					if(timestamp>0){
						var theDate = new Date(timestamp * 1000);
						dateString = theDate.toGMTString();
						dateString = dateString.replace(/GMT/,'')
					}else{
						dateString = "";
					}
					xulNodeFormatted.setAttribute('value', dateString)
				}
			}
		}
	},

	treecols : {
		create : function(e4x){
			var tmpXulObject = document.createElement('treecols')

			var headerCounter=0
			for each(var header in e4x.*)
			{
				var tmpItemNode = document.createElement('treecol')
				tmpItemNode.setAttribute('id', header.name())
				tmpItemNode.setAttribute('label',cs_Core.locale.getStringFromName('db.variables.'+header.name()))

				for each(var attribute in header.@*){
					if(attribute.name()=='src'){
						//log('setting image to treecol '+attribute.name()+' chrome://cyclone/skin/'+attribute)
						tmpItemNode.setAttribute(attribute.name(), "chrome://cyclone/skin/"+attribute)
						tmpItemNode.setAttribute('class', 'treecol-image')
					}else{
						tmpItemNode.setAttribute(attribute.name(), attribute)
					}
				}

				tmpItemNode = tmpXulObject.appendChild(tmpItemNode)

				headerCounter++
				if(e4x.header.*.length()>headerCounter){
					var tmpItemNodeSplitter = tmpXulObject.appendChild(document.createElement('splitter'))
					tmpItemNodeSplitter.setAttribute('class', "tree-splitter")
				}
			}
			return tmpXulObject
		}
	},

	tree : {

		create : function(e4x){
			var tmpXulObject

			tmpXulObject = document.createElement('tree');
			tmpXulObject.setAttribute('enableColumnDrag', true)

			var tmpXulObjectHeader = tmpXulObject.appendChild(ui.toolbox.treecols.create(e4x.header))

			var tmpXulObjectTreechildren = tmpXulObject.appendChild(document.createElement('treechildren'));

			tmpXulObject.xmlData = e4x

			for each(var item in e4x.item)
			{
				var tmpItemNode = ui.toolbox.tree.treeitem.create(item)

				//tmpItemNode.setAttribute('src', "chrome://cyclone/skin/icons/16x16/a400.png")
				//tmpItemNode.setAttribute('properties', "withimage")

				tmpItemNode = tmpXulObjectTreechildren.appendChild(tmpItemNode)
			}

			var tmpItems=tmpXulObject.getElementsByTagName('treeitem')
			for(i=0;i<tmpItems.length;i++){
				if(tmpItems[i].getElementsByTagName('treechildren').length){
					//log("item "+tmpItems[i].tagName+" of IDitem "+tmpItems[i].getAttribute('IDitem')+" has children!!!");
					tmpItems[i].setAttribute('container', true);
				}
			}

			return tmpXulObject
		},

		selection : {

			get : function (xulTree) {
				var itemArray = new Array

				var selCount = xulTree.view.selection.getRangeCount();

				for (var i=0; i<selCount; i++)
				{
					var start = new Object();
					var end = new Object();

					xulTree.view.selection.getRangeAt(i,start,end);
					for (var j=start.value; j<=end.value; j++)
					{
						try{
							//this is a DOM-based tree, returning rows
							if(xulTree.view.getItemAtIndex(j).getElementsByTagName('treerow').length>0){
								//cs_Core.log.append("Item "+j+" is selected and has IDitem value "+xulTree.contentView.getItemAtIndex(j).getAttribute('IDitem'));
								//toto pcha do arrayu ref na cell, neviem naco som to chcel :-O
								//itemArray.push(xulTree.contentView.getItemAtIndex(j).getElementsByTagName('treerow')[0].getElementsByTagName('treecell')[0]);
								//alert("LOL"+xulTree.contentView.getItemAtIndex(j).getAttribute('IDitem'))
								itemArray.push(xulTree.view.getItemAtIndex(j));
							}
						}
						catch(e)
						{
							//this is a custom-view tree, returning row ID's
							if(xulTree.treeBoxObject.columns.getNamedColumn("ID")){
								itemArray.push(j)
							}
						}
					}
				}
				return itemArray;
			}
		},

		items : {
			edit : function(xulTree) {
try{
				var tmpSelection=ui.toolbox.tree.selection.get(xulTree)
}catch(e){
alert(e)
}
				for(var i=0; i<tmpSelection.length; i++)
				{
					var tmpLng=""

					//TODO: do we want to have it this way, or would it be better to get an object with row's values instead?)
					if(typeof(tmpSelection[i])=='number'){
						if(xulTree.treeBoxObject.columns.getNamedColumn("lng")){
							tmpLng = xulTree.view.getCellValue(tmpSelection[i], xulTree.treeBoxObject.columns.getNamedColumn("lng"))
						}
						//selection from a custom view
						if(xulTree.treeBoxObject.columns.getNamedColumn("ID")){
							Handler.fnc_create(
								{},
								"",
								{
									type: xulTree.getAttribute('IDapp')+"_detail",
									ID: xulTree.view.getCellValue(tmpSelection[i], xulTree.treeBoxObject.columns.getNamedColumn("ID")),
									lng: tmpLng
								}
							)
						}else{
							log('can\'t get ID column for row '+tmpSelection[i])
						}
					}else{
						if(tmpSelection[i].hasAttribute('lng')){
							tmpLng = tmpSelection[i].getAttribute('lng')
						}

						//selection from a custom view
						if(tmpSelection[i].getAttribute('IDitem')){
							Handler.fnc_create(
								{},
								"",
								{
									type: xulTree.getAttribute('IDapp')+"_detail",
									ID: tmpSelection[i].getAttribute('IDitem'),
									lng: tmpLng
								}
							)
						}
					}
				}
			},

			remove : function(xulTree) {
				var tmpSelection=ui.toolbox.tree.selection.get(xulTree)

				for(var i=0; i<tmpSelection.length; i++)
				{
					Handler.fnc_create({}, "", { type: xulTree.getAttribute('IDapp')+"_delete", ID: tmpSelection[i].getAttribute('IDitem')})
				}
			},

			list : function(xulTree) {
				var tmpSelection=ui.toolbox.anonymous.selection.get(xulTree)

				for(var i=0; i<tmpSelection.length; i++)
				{
					var IDapp=tmpSelection[i].getAttribute('IDapp')
					if(!IDapp){
						//element nema appid, skusime sa vybublinkovat az k najparentovskejsiemu nodu
						var tmpParent=tmpSelection[i].parentNode
						while(!IDapp){
							IDapp=tmpParent.getAttribute('IDapp')

							if(tmpParent==xulTree){
								//najparentovskejsi parento, koncime, nevladzeme viac
								break
							}
							tmpParent=tmpParent.parentNode
						}

						if(!IDapp){
							//alert(xulTree.getAttribute('id'))
							log("the item '"+tmpSelection[i].getAttribute('IDitem')+"' does not have IDapp defined!!!")
							return null
						}
					}
					//alert("gateway: "+document.getElementById('content-list'))
					if(IDapp){
						Handler.fnc_create(
							{
								gateway: document.getElementById('content-list')
							},
							"",
							{
								type: IDapp+"_list",
								IDcategory: tmpSelection[i].getAttribute('IDitem'),
								lng: cs_Core.config.lng
							}
						)
					}
				}
				return null
			}
		},

		treeitem : {

			create : function(e4x){
				var tmpTreeitem = document.createElement('treeitem');

				tmpTreeitem.setAttribute('IDitem', e4x.@IDitem)

				var tmpTreeitemRow = tmpTreeitem.appendChild(document.createElement('treerow'))

				for each(var col in e4x.*)
				{
					var tmpTreetemNodeRowCell = tmpTreeitemRow.appendChild(document.createElement('treecell'))

					var itemProps=[]

					for each(var attribute in col.@*){
						if(attribute.name()=="src"){
							//var tmpImage = document.createElement('image')
							//var absPath=attribute.toString()
							//absPath=absPath.replace(/http:\/\/media.webcom.sk\//, "https://virtual.webcom.sk/media/")
							//tmpImage.setAttribute('src', absPath)

							//tmpTreetemNodeRowCell.appendChild(tmpImage)

							tmpTreetemNodeRowCell.setAttribute('src', 'chrome://cyclone/skin/'+attribute)
						}
						tmpTreetemNodeRowCell.setAttribute(attribute.name(), attribute)
					}
					tmpTreetemNodeRowCell.setAttribute('label', col)
					tmpTreetemNodeRowCell.setAttribute('value', col)

					if(col.name()=='active'){
						itemProps.push('active_'+col)
					}
					//log('xx:'+itemProps.join(" "))
					tmpTreetemNodeRowCell.setAttribute('properties', itemProps.join(" "))
				}
				//log("created an element with IDitem attribute of:"+tmpTreeitem.getAttribute('IDitem'))
				return tmpTreeitem
			}
		},

		treecell : {

			onclick : function (xulNode, event){
				var row = new Object()
				var col = new Object()
				var childElement = new Object()

				xulNode.treeBoxObject.getCellAt(event.clientX, event.clientY, row, col, childElement)

				var refreshNeeded;

				row = row.value
				col = col.value
				childElement = childElement.value

				var arrayComp = Components.classes['@mozilla.org/supports-array;1'].createInstance()
				var properties = arrayComp.QueryInterface(Components.interfaces.nsISupportsArray)

				var stopEvent

				var tmpLng=""
				if(xulNode.treeBoxObject.columns.getNamedColumn("lng")){
					tmpLng = xulNode.view.getCellValue(row, xulNode.treeBoxObject.columns.getNamedColumn("lng"))
				}

				if (col){
					switch (col.id){
						case 'active':
							var tmpValue = xulNode.view.getCellValue(row, col)
							switch(tmpValue){
								case "Y":
									if(xulNode.treeBoxObject.columns.getNamedColumn("ID")){
										Handler.fnc_create(
											{
												action: function() {xulNode.view.setCellValue(row, col, "N")}
											},
											"",
											{
												type: "set_active",
												IDapp: ui.toolbox.anonymous.getIDapp(xulNode, xulNode),
												ID: xulNode.view.getCellValue(row, xulNode.treeBoxObject.columns.getNamedColumn("ID")),
												lng: tmpLng,
												active: "N"
											}
										)
									}
									break
								case "N":
									if(xulNode.treeBoxObject.columns.getNamedColumn("ID")){
										Handler.fnc_create(
											{
												action: function() {xulNode.view.setCellValue(row, col, "Y")}
											},
											"",
											{
												type: "set_active",
												IDapp: ui.toolbox.anonymous.getIDapp(xulNode, xulNode),
												ID: xulNode.view.getCellValue(row, xulNode.treeBoxObject.columns.getNamedColumn("ID")),
												lng: tmpLng,
												active: "Y"
											})
									}
									break
								default:
									break
							}
							break
						default:
							if(col.id.substring(0,8)=="priority"){
								if(event.altKey)
								{
									var tmpValue = xulNode.view.getCellValue(row, col)

									if(xulNode.treeBoxObject.columns.getNamedColumn("ID")){
										Handler.fnc_create(
											{
												action: function(returnedValue) {xulNode.view.setCellValue(row, col, returnedValue)}
											},
											"",
											{
												type: "set_priority",
												IDapp: ui.toolbox.anonymous.getIDapp(xulNode, xulNode),
												ID: xulNode.view.getCellValue(row, xulNode.treeBoxObject.columns.getNamedColumn("ID")),
												lng: tmpLng,
												priority: "-",
												level: col.id.substring(8,9).toString()
											}
										)
									}
								}else{
									var tmpValue = xulNode.view.getCellValue(row, col)

									if(xulNode.treeBoxObject.columns.getNamedColumn("ID")){
										Handler.fnc_create(
											{
												action: function(returnedValue) {xulNode.view.setCellValue(row, col, returnedValue)}
											},
											"",
											{
												type: "set_priority",
												IDapp: ui.toolbox.anonymous.getIDapp(xulNode, xulNode),
												ID: xulNode.view.getCellValue(row, xulNode.treeBoxObject.columns.getNamedColumn("ID")),
												lng: tmpLng,
												priority: "+",
												level: col.id.substring(8,9).toString()
											}
										)
									}
								}
								/*
								if(tmpValue==9){
									xulNode.view.setCellValue(row, col, "0")
								}else{
									xulNode.view.setCellValue(row, col, parseInt(tmpValue)+1)
								}*/
							}
							break
					}
				}
			}
		},

		getTree : function (xulNode) {
			var tmpNodeName=xulNode.nodeName.toString()
			tmpNodeName=tmpNodeName.replace(/^xul:/, '')
			if(tmpNodeName=='tree'){
				return xulNode
			}else{
				while(xulNode.parentNode){
					xulNode = xulNode.parentNode

					tmpNodeName=xulNode.nodeName.toString()
					tmpNodeName=tmpNodeName.replace(/^xul:/, '')

					if((xulNode.nodeName=='tree')||(xulNode.nodeName=='xul:tree')){
						return xulNode
					}else	if(xulNode==document){
						return null
					}
				}
			}
			return null
		}
	},

	listbox : {
		create : function(e4x){
			var tmpXulObject

			tmpXulObject = document.createElement('listbox');

			var tmpXulObjectHeader = tmpXulObject.appendChild(document.createElement('listhead'));
			var tmpXulObjectListcols = tmpXulObject.appendChild(document.createElement('listcols'));

			for each(var header in e4x.header.*)
			{
				var tmpItemNode = tmpXulObjectHeader.appendChild(document.createElement('listheader'))
				tmpItemNode.setAttribute('id', header.name())

				tmpItemNode.setAttribute('label',cs_Core.locale.getStringFromName('db.variables.'+header.name()))

				for each(var attribute in header.@*){
					tmpItemNode.setAttribute(attribute.name(), attribute)
				}

				tmpItemNode = tmpXulObjectListcols.appendChild(document.createElement('listcol'))

				for each(var attribute in header.@*){
					tmpItemNode.setAttribute(attribute.name(), attribute)
				}
			}

			for each(var item in e4x.item)
			{
				var tmpItemNode = ui.toolbox.listbox.listitem.create(item)
				tmpItemNode = tmpXulObject.appendChild(tmpItemNode)
			}

			var tmpItems=tmpXulObject.getElementsByTagName('treeitem')
			for(i=0;i<tmpItems.length;i++){
				if(tmpItems[i].getElementsByTagName('treechildren').length){
					//log("item "+tmpItems[i].tagName+" of IDitem "+tmpItems[i].getAttribute('IDitem')+" has children!!!");
					tmpItems[i].setAttribute('container', true);
				}
			}

			return tmpXulObject
		},

		listitem : {
			create : function(e4x){
				var tmpListitem = document.createElement('listitem');

				tmpListitem.setAttribute('IDitem', e4x.@IDitem)

				for each(var col in e4x.*)
				{
					var tmpListcell = tmpListitem.appendChild(document.createElement('listcell'))

					for each(var attribute in col.@*){
						if(attribute.name()=="src"){
							var tmpImage = document.createElement('image')
							var absPath=attribute.toString()
							//absPath=absPath.replace(/http:\/\/media.webcom.sk\//, "https://virtual.webcom.sk/media/")
							tmpImage.setAttribute('src', absPath)
							tmpListcell.appendChild(tmpImage)
						}
						tmpListcell.setAttribute(attribute.name(), attribute)
					}

					tmpListcell.setAttribute('label', col)
				}
				//log("created an element with IDitem attribute of:"+tmpListitem.getAttribute('IDitem'))
				return tmpListitem
			}
		}
	},

	menupopup : {
/*
		init : function(tmpPopup){
			if(tmpPopup.getAttribute('id')=='content-folders-context'){
				if(!ui.toolbox.tree.selection.get(document.getElementById('content-folders'))[0]){
					return false
				}
				var tmpIDapp=ui.toolbox.anonymous.getIDapp(ui.toolbox.tree.selection.get(document.getElementById('content-folders'))[0], document.getElementById('content-folders'))

				if(tmpPopup.getElementsByTagName('menuitem').length){
					for(var i=0;i<tmpPopup.getElementsByTagName('menuitem').length;i++){
						var tmpMenuItem=tmpPopup.getElementsByTagName('menuitem')[i]

						if(tmpMenuItem.hasAttribute('IDapp')){
							if(tmpMenuItem.getAttribute('IDapp')==tmpIDapp){
								tmpMenuItem.removeAttribute('hidden')
							}else{
								tmpMenuItem.setAttribute('hidden', true)
							}
						}else{
							tmpMenuItem.removeAttribute('hidden')
						}
					}
				}
				return true
			}
			return false
		}
*/
	},

	menulist : {

		create: function(e4x, fncSetup){
			var tmpXulObject

			tmpXulObject = document.createElement('menulist');

			var tmpXulMenupopup = tmpXulObject.appendChild(document.createElement('menupopup'));

			if(fncSetup.addBlankRecord){
    			var tmpItemNode = document.createElement('menuitem')

				tmpItemNode.setAttribute('IDitem', "")
				tmpItemNode.setAttribute('label', "")
				tmpItemNode.value=""

				tmpItemNode = tmpXulMenupopup.appendChild(tmpItemNode)
			}

			for each(var item in e4x.item)
			{
				if(item[fncSetup.var_active] == 'N' && fncSetup.var_allow!=item[fncSetup.var_value]){continue}
				
				var tmpItemNode = document.createElement('menuitem')

				tmpItemNode.setAttribute('label', item[fncSetup.var_label])
				tmpItemNode.setAttribute('value', item[fncSetup.var_value])
				tmpItemNode.setAttribute('is_default', item[fncSetup.var_is_default])
				tmpItemNode.value=item[fncSetup.var_value]

				log('setting value '+item[fncSetup.var_value]+' for menuitem '+item[fncSetup.var_label])

				tmpItemNode = tmpXulMenupopup.appendChild(tmpItemNode)
			}

			return tmpXulObject
/*
											<menulist label="More">
												<menupopup>
													<menu label="More" >
														<menupopup>
															<menuitem label="A" />
															<menuitem label="B" />
															<menuitem label="C" />
															<menuseparator />
															<menu label="More" >
															<menupopup>
																<menuitem label="1" />
																<menuitem label="2" />
																<menuitem label="3" />
															</menupopup>
															</menu>
														</menupopup>
													</menu>
													<menuseparator />
													<menuitem label="X" />
													<menuitem label="Y" />
													<menuitem label="Z" />
												</menupopup>
											</menulist>
*/
		}
	},
	
	popup : {

		create: function(e4x, fncSetup){
		
		try{
			var tmpXulObject

			tmpXulObject = document.createElement('popup');

			if(fncSetup.addBlankRecord){
    			var tmpItemNode = document.createElement('menuitem')

				tmpItemNode.setAttribute('IDitem', "")
				tmpItemNode.setAttribute('label', "")
				tmpItemNode.setAttribute('is_default', "")
				tmpItemNode.value=""
				
				tmpItemNode.addEventListener("click", fncSetup.var_function ,false)

				tmpItemNode = tmpXulObject.appendChild(tmpItemNode)
			}

			for each(var item in e4x.item)
			{
				if(item[fncSetup.var_active] == 'N' && fncSetup.var_allow!=item[fncSetup.var_value]){continue}
				
				var tmpItemNode = document.createElement('menuitem')

				tmpItemNode.setAttribute('label', item[fncSetup.var_label])
				tmpItemNode.setAttribute('value', item[fncSetup.var_value])
				tmpItemNode.setAttribute('is_default', item[fncSetup.var_is_default])
				tmpItemNode.value=item[fncSetup.var_value]
				
				tmpItemNode.addEventListener("click", fncSetup.var_function,false)

				tmpItemNode = tmpXulObject.appendChild(tmpItemNode)
			}

			return tmpXulObject
			
		}catch(e){alert(e)}
/*
											<menulist label="More">
												<menupopup>
													<menu label="More" >
														<menupopup>
															<menuitem label="A" />
															<menuitem label="B" />
															<menuitem label="C" />
															<menuseparator />
															<menu label="More" >
															<menupopup>
																<menuitem label="1" />
																<menuitem label="2" />
																<menuitem label="3" />
															</menupopup>
															</menu>
														</menupopup>
													</menu>
													<menuseparator />
													<menuitem label="X" />
													<menuitem label="Y" />
													<menuitem label="Z" />
												</menupopup>
											</menulist>
*/
		}
	},

	grid : {
		create: function(e4x){
			var tmpXulObject

			return tmpXulObject
		}
	},

	tab : {
		close: function(xulNode){
			if(xulNode.nodeName=='tabpanel'){
				var tmpTabs=xulNode.parentNode.parentNode.getElementsByTagName('tabs')[0].getElementsByTagName('tab')
				for (var i=0;i<tmpTabs.length;i++){
					if(tmpTabs[i].getAttribute('linkedpanel')==xulNode.getAttribute('id')){
						tmpTabs[i].removeAttribute('linkedpanel')
						xulNode.parentNode.removeChild(xulNode)
						tmpTabs[i].parentNode.advanceSelectedTab(-1)
						tmpTabs[i].parentNode.removeItemAt(i)
					}
				}
			}else if(xulNode.nodeName=='tab'){
				//alert(xulNode.parentNode.nodeName)
				//alert(xulNode.parentNode.parentNode.nodeName)
				//alert(xulNode.getAttribute('linkedpanel'))
				//alert(xulNode.parentNode.parentNode.getElementById(xulNode.getAttribute('linkedpanel')))
				var tmpTabPanel=document.getElementById(xulNode.getAttribute('linkedpanel'))
				if(tmpTabPanel){
					xulNode.parentNode.advanceSelectedTab(-1)
					tmpTabPanel.parentNode.removeChild(tmpTabPanel)
					xulNode.parentNode.removeChild(xulNode)
				}
			}
		}
	},

	dialog : {
		fileOpen : function(){
			var nsIFilePicker = Components.classes["@mozilla.org/filepicker;1"].createInstance(Components.interfaces.nsIFilePicker)
			nsIFilePicker.init(window, "Open file", Components.interfaces.nsIFilePicker.modeOpen);
			nsIFilePicker.appendFilter("All files", "*.*");
			if (nsIFilePicker.show() == Components.interfaces.nsIFilePicker.returnOK)
			{
				return nsIFilePicker.file
			}else{
				return null
			}
		}
/*
		onDialogConfirm : function (dataObject){
			if(dataObject.dialogType){
				var tmpSetup = {}
				var tmpArguments = {}

				if(dataObject.dialogType=='category-edit'){
					dataObject.dialogWin.close()
					delete dataObject.dialogType
					delete dataObject.dialogWin
					//alert('creating category :)')

					for(var item in dataObject){
						tmpArguments[item]=dataObject[item]
					}
					tmpArguments.type = ui.toolbox.anonymous.getIDapp(ui.toolbox.tree.selection.get(document.getElementById('content-folders'))[0], document.getElementById('content-folders'))+'_category_add'
					tmpArguments.IDparent = ui.toolbox.tree.selection.get(document.getElementById('content-folders'))[0].getAttribute('IDitem')
					tmpArguments.IDapp = ui.toolbox.anonymous.getIDapp(ui.toolbox.tree.selection.get(document.getElementById('content-folders'))[0], document.getElementById('content-folders'))

					var tmpSelectedItems=new Array()
					if(ui.toolbox.tree.selection.get(document.getElementById('content-folders'))[0].getAttribute('IDitem')){
						tmpSelectedItems.push(ui.toolbox.tree.selection.get(document.getElementById('content-folders'))[0].getAttribute('IDitem'))
					}

					tmpSetup.action = function(){
						Handler.fnc_create(
							{
								gateway : document.getElementById(
									'content-folders-'+ui.toolbox.anonymous.getIDapp(
										ui.toolbox.tree.selection.get(document.getElementById('content-folders'))[0],
										document.getElementById('content-folders')
									)
								),
								replaceMode: 'treechildren',
								selectedItems : tmpSelectedItems
							},
							'',
							{
								type: ui.toolbox.anonymous.getIDapp(
									ui.toolbox.tree.selection.get(document.getElementById('content-folders'))[0],
									document.getElementById('content-folders')
								)+'_tree',
								lng : cs_Core.config.lng
							}
						)
					}

					//for(var item in tmpArguments){
					//	if(item=='openerXulNode'){ continue; }
					//	alert('adding '+item+' ('+tmpArguments[item]+')')
					//}

					//workaround for mozilla BUG 317600 - can't call opener's xmlhttp requester from popup window, it is bound to popup, not the opener itself
					window.setTimeout(
						function(){
							Handler.fnc_create(
								tmpSetup,
								'',
								tmpArguments
							)
						},
						0
					)
				}
			}
		}
*/
	},

	stringBundle : {

		get : function(stringBundlePath){
			try
			{
				var localeService =
					Components
					.classes["@mozilla.org/intl/nslocaleservice;1"]
					.getService(Components.interfaces.nsILocaleService);
				var appLocale =  localeService.getApplicationLocale();

				var stringBundleService =
					Components.classes["@mozilla.org/intl/stringbundle;1"]
					.getService(Components.interfaces.nsIStringBundleService);

				return stringBundleService.createBundle(stringBundlePath, appLocale);
			}
			catch(e)
			{
				alert(e);
			}
			return false;
		}

	}

}
