// *********************************************
//  Applications
// *********************************************


function App(id)
{
	this.id = id
	this.setup = new Array()
}


App.prototype.tree = function (e4x, IDrequest)
{
	this.setup.e4x = e4x
	
	if (!arr_globalRequestPoll[IDrequest].setup.replaceMode)
	{
		arr_globalRequestPoll[IDrequest].setup.replaceMode="direct"
	}
	
	if(!arr_globalRequestPoll[IDrequest].setup.objectMode)
	{
		arr_globalRequestPoll[IDrequest].setup.objectMode="tree"
	}
	
	var tmpTimestamp=new Date().getTime()
	
	var tmpXulObject = ui[this.id].tree(e4x,arr_globalRequestPoll[IDrequest].setup.objectMode)
	
	if(typeof(tmpXulObject)=="object")
	{
		tmpXulObject.setAttribute('id',tmpTimestamp)
		tmpXulObject.setAttribute('IDrequest', IDrequest)
		
		var newNode
		
		if(arr_globalRequestPoll[IDrequest].setup.replaceMode=='direct')
		{
			//budeme replacovat gateway samotny
			if(arr_globalRequestPoll[IDrequest].setup.gateway)
			{
				//mame specifikovany konkretny gateway
				var oldId;
				if (arr_globalRequestPoll[IDrequest].setup.gateway.getAttribute('id'))
				{
					//backup id-cka gateway objektu, ktory ideme replacnut - budeme ho potrebovat, aby sme sa nan mohli v buducnosti odkazat
					oldId = arr_globalRequestPoll[IDrequest].setup.gateway.getAttribute('id')
				}
				
				//clearing selection - seems to cause onselect event to fire, when replacing the tree (causes errors f.e. when replacing content-folders)
				if (arr_globalRequestPoll[IDrequest].setup.objectMode=="tree")
				{
					var tmpGatewayTree = ui.toolbox.tree.getTree(arr_globalRequestPoll[IDrequest].setup.gateway)
					tmpGatewayTree.view.selection.clearSelection()
				}
				
				var replacedNode =
					arr_globalRequestPoll[IDrequest].setup.gateway.parentNode.replaceChild
					(
						tmpXulObject,
						arr_globalRequestPoll[IDrequest].setup.gateway
					)
				
				newNode = document.getElementById(tmpTimestamp)
				
				if(oldId)
				{
					newNode.setAttribute('id',oldId)
				}
				else
				{
					newNode.removeAttribute('id')
				}
				
				//fixujeme referencie na stary objekt - presmerovanim na novy
				for each(var tmpSetup in arr_globalRequestPoll)
				{
					if(tmpSetup.setup)
					{
						if(tmpSetup.setup.gateway==replacedNode)
						{
							tmpSetup.setup.gateway=newNode
						}
					}
				}
				
				//arr_globalRequestPoll[IDrequest].setup.gateway=newNode
			}
			else
			{
				arr_globalRequestPoll[IDrequest].setup.gateway=document.getElementById('content-list')
				arr_globalRequestPoll[IDrequest].setup.gateway.parentNode.replaceChild(tmpXulObject, arr_globalRequestPoll[IDrequest].setup.gateway)
				arr_globalRequestPoll[IDrequest].setup.gateway=document.getElementById('content-list')
			}
			
			//var newNode = document.getElementById(tmpTimestamp)
		}
		else if (arr_globalRequestPoll[IDrequest].setup.replaceMode=='treechildren')
		{
			if(arr_globalRequestPoll[IDrequest].setup.objectMode=="tree")
			{
				if(!arr_globalRequestPoll[IDrequest].setup.gateway)
				{
					arr_globalRequestPoll[IDrequest].setup.gateway=
						document.getElementById('content-folders')
				}
				
				//clearing selection - seems to cause onselect event to fire, when replacing the tree (causes errors f.e. when replacing content-folders)
				if(arr_globalRequestPoll[IDrequest].setup.objectMode=="tree")
				{
					var tmpGatewayTree = ui.toolbox.tree.getTree(arr_globalRequestPoll[IDrequest].setup.gateway)
					tmpGatewayTree.view.selection.clearSelection()
				}
				
				var tmpTreechildren = arr_globalRequestPoll[IDrequest].setup.gateway.getElementsByTagName('treechildren')[0]
				
				while(tmpTreechildren.firstChild)
				{
					tmpTreechildren.removeChild(tmpTreechildren.firstChild)
				}
				
				while(tmpXulObject.getElementsByTagName('treechildren')[0].childNodes.length)
				{
					arr_globalRequestPoll[IDrequest].setup.gateway.getElementsByTagName('treechildren')[0].appendChild(
						tmpXulObject.getElementsByTagName('treechildren')[0].childNodes[0]
					)
				}
				
				newNode = arr_globalRequestPoll[IDrequest].setup.gateway
				
			}
			else
			{
				//another type of object
			}
			
		}
		
		//setting IDrequest attribute (can be retrieved later, to consistently redo the same, or slightly changed request again without doing the whole setup thingy again)
		newNode.setAttribute('IDrequest', IDrequest)
		
		var tmpNodeName=newNode.nodeName.toString()
		tmpNodeName=tmpNodeName.replace(/^xul:/, '')
		
		switch (tmpNodeName)
		{
			case 'tree':
				//check treeitems
				if(arr_globalRequestPoll[IDrequest].setup.selectedItems)
				{
					var i;
					for(i=0;i<arr_globalRequestPoll[IDrequest].setup.selectedItems.length;i++)
					{
						var findItem=true
						while(findItem)
						{
							for(j=0;j<arr_globalRequestPoll[IDrequest].setup.selectedItems[i].toString().length;j++)
							{
								var tmpID = arr_globalRequestPoll[IDrequest].setup.selectedItems[i].toString().substring(0,j+1)
								
								for(k=0;k<newNode.view.rowCount;k++)
								{
									var tmpRow =newNode.contentView.getItemAtIndex(k)
									if(tmpRow.getAttribute('IDitem')==tmpID)
									{
										if(newNode.view.isContainer(k))
										{
											newNode.view.toggleOpenState(k)
										}
										if(j==arr_globalRequestPoll[IDrequest].setup.selectedItems[i].toString().length-1)
										{
											newNode.view.selection.toggleSelect(k)
										}
										break
									}
								}
								
								if(j==arr_globalRequestPoll[IDrequest].setup.selectedItems[i].toString().length-1)
								{
									findItem=false
								}
							}
							findItem=false
						}
					}
				}
				break
			
			case 'listbox':
				//check listitems
				break
			
			case 'menulist':
				if(arr_globalRequestPoll[IDrequest].setup.selectedItems)
				{
					if(arr_globalRequestPoll[IDrequest].setup.selectedItems.length)
					{
						var i;
						for(i=0;i<arr_globalRequestPoll[IDrequest].setup.selectedItems.length;i++)
						{
							//log('checking list for value of '+arr_globalRequestPoll[IDrequest].setup.selectedItems[i])
							var tmpMenuItems=newNode.getElementsByTagName('menuitem')
							for(var j=0;j<tmpMenuItems.length;j++)
							{
								//log('list item '+j+' has value of '+tmpMenuItems[j].getAttribute('IDitem'))
								if(arr_globalRequestPoll[IDrequest].setup.selectedItems[i]==tmpMenuItems[j].getAttribute('IDitem'))
								{
									//log('newNode '+newNode.nodeName)
									//log('setting selection to '+j)
									newNode.selectedIndex=j;
									break
								}
							}
						}
					}
				}
				break
		}
	}
}


App.prototype.list = function (e4x, IDrequest)
{
	this.setup.e4x = e4x
	
	if(!arr_globalRequestPoll[IDrequest].setup)
	{
		arr_globalRequestPoll[IDrequest].setup={}
	}
	
	if(!arr_globalRequestPoll[IDrequest].setup.replaceMode)
	{
		arr_globalRequestPoll[IDrequest].setup.replaceMode="direct"
	}
	if(!arr_globalRequestPoll[IDrequest].setup.objectMode)
	{
		arr_globalRequestPoll[IDrequest].setup.objectMode="tree"
	}
	
	var tmpTimestamp=new Date().getTime()
	
	var newNode
	
	if
	(
		(arr_globalRequestPoll[IDrequest].setup.gateway==document.getElementById('content-list'))
		||(!arr_globalRequestPoll[IDrequest].setup.gateway)
	)
	{
		if (document.getElementById('content-tab-list').prop_IDapp!=e4x.@IDapp)
		{
			//panel nema IDapp, alebo nie je panelom listingu ankiet, takze ho zamenime
			var tmpTimestamp=new Date().getTime()
			var tmpPanel=document.createElement('tabpanel')
			tmpPanel.setAttribute('id', 'panel-'+tmpTimestamp)
			
			document.getElementById('content-tab-list').parentNode.replaceChild(tmpPanel, document.getElementById('content-tab-list'))
			tmpPanel=document.getElementById('panel-'+tmpTimestamp)
			tmpPanel.setAttribute('id', 'content-tab-list')
			tmpPanel.setAttribute('class', 'list-'+e4x.@IDapp)
			newNode=tmpPanel
		}
		else
		{
			//displayed panel is already an tmpIDapp panel, so we just reuse the content element
			newNode=document.getElementById('content-tab-list')
		}
		var intervalID = window.setInterval
		(
			function()
			{
				if(document.getElementById('content-tab-list').fnc_init)
				{
					document.getElementById('content-tab-list').fnc_init(e4x, IDrequest)
					window.clearInterval(intervalID)
				}
			},
			100
		)
	}
	else
	{
		var tmpXulObject = ui[this.id].list(e4x,IDrequest)
		
		if (typeof(tmpXulObject)=="object")
		{
			tmpXulObject.setAttribute('id',tmpTimestamp)
			tmpXulObject.setAttribute('IDrequest', IDrequest)
			
			if (arr_globalRequestPoll[IDrequest].setup.replaceMode=='direct')
			{
				//budeme replacovat gateway samotny
				if (arr_globalRequestPoll[IDrequest].setup.gateway)
				{
					//mame specifikovany konkretny gateway
					var oldId;
					if (arr_globalRequestPoll[IDrequest].setup.gateway.getAttribute('id'))
					{
						//backup id-cka gateway objektu, ktory ideme replacnut - budeme ho potrebovat, aby sme sa nan mohli v buducnosti odkazat
						oldId = arr_globalRequestPoll[IDrequest].setup.gateway.getAttribute('id')
					}
					var oldIdData;
					if (arr_globalRequestPoll[IDrequest].setup.gateway.getAttribute('IDdata'))
					{
						//backup iddata
						oldIdData = arr_globalRequestPoll[IDrequest].setup.gateway.getAttribute('IDdata')
					}
					var oldIdAnon;
					if (arr_globalRequestPoll[IDrequest].setup.gateway.getAttribute('IDanon'))
					{
						//backup idanon
						oldIdAnon = arr_globalRequestPoll[IDrequest].setup.gateway.getAttribute('IDanon')
					}
					
					var oldIDtoolbar;
					if (arr_globalRequestPoll[IDrequest].setup.gateway.getAttribute('IDtoolbar'))
					{
						//backup id-cka IDtoolbar objektu, ktory ideme replacnut - budeme ho potrebovat, aby sme sa nan mohli v buducnosti odkazat
						oldIDtoolbar = arr_globalRequestPoll[IDrequest].setup.gateway.getAttribute('IDtoolbar')
					}
					
					var replacedNode = arr_globalRequestPoll[IDrequest].setup.gateway.parentNode.replaceChild(tmpXulObject, arr_globalRequestPoll[IDrequest].setup.gateway)
					
					newNode = document.getElementById(tmpTimestamp)
					
					if(oldId)
					{
						newNode.setAttribute('id',oldId)
					}
					else
					{
						newNode.removeAttribute('id')
					}
					
					if(oldIdData)
					{
						newNode.setAttribute('IDdata',oldIdData)
					}
					
					if(oldIdAnon)
					{
						newNode.setAttribute('IDanon',oldIdAnon)
					}
					
					//fixujeme referencie na stary objekt - presmerovanim na novy
					for each(var tmpSetup in arr_globalRequestPoll)
					{
						if(tmpSetup.setup)
						{
							if(tmpSetup.setup.gateway==replacedNode)
							{
								tmpSetup.setup.gateway=newNode
							}
						}
					}
					
					if(oldIDtoolbar)
					{
						newNode.setAttribute('IDtoolbar',oldIDtoolbar)
					}
					
					//arr_globalRequestPoll[IDrequest].setup.gateway=newNode
				}
				else
				{
					arr_globalRequestPoll[IDrequest].setup.gateway = document.getElementById('content-list')
					arr_globalRequestPoll[IDrequest].setup.gateway.parentNode.replaceChild(tmpXulObject, arr_globalRequestPoll[IDrequest].setup.gateway)
					arr_globalRequestPoll[IDrequest].setup.gateway = document.getElementById('content-list')
				}
				
				//var newNode = document.getElementById(tmpTimestamp)
			}
			else if(arr_globalRequestPoll[IDrequest].setup.replaceMode=='treechildren')
			{
				if (!arr_globalRequestPoll[IDrequest].setup.gateway)
				{
					arr_globalRequestPoll[IDrequest].setup.gateway = document.getElementById('content-list')
				}

				while(arr_globalRequestPoll[IDrequest].setup.gateway.getElementsByTagName('treechildren')[0].firstChild)
				{
					arr_globalRequestPoll[IDrequest].setup.gateway.removeChild(arr_globalRequestPoll[IDrequest].setup.gateway.getElementsByTagName('treechildren')[0].firstChild)
				}
				while(tmpXulObject.getElementsByTagName('treechildren')[0].childNodes.length)
				{
					arr_globalRequestPoll[IDrequest].setup.gateway.getElementsByTagName('treechildren')[0].appendChild(tmpXulObject.getElementsByTagName('treechildren')[0].childNodes[0])
				}
				
			}
		}
		
		newNode = arr_globalRequestPoll[IDrequest].setup.gateway
		
		//setting IDrequest attribute (can be retrieved later, to consistently redo the same, or slightly changed request again without doing the whole setup thingy again)
		newNode.setAttribute('IDrequest', IDrequest)
		
		//log('newNode.nodeName='+newNode.nodeName)
		
		switch (newNode.nodeName)
		{
			case 'tree':
				//log('do we have selectedItems for tree?')
				//check treeitems
				if(arr_globalRequestPoll[IDrequest].setup.selectedItems)
				{
					//log('we have selecedItems for this tree')
					var i;
					for(i=0;i<arr_globalRequestPoll[IDrequest].setup.selectedItems.length;i++)
					{
						var tmpTreeItems=newNode.getElementsByTagName('treeitem')
						//log('treeitem element count: '+tmpTreeItems.length)
						for(var j=0;j<tmpMenuItems.length;j++)
						{
							if(arr_globalRequestPoll[IDrequest].setup.selectedItems[i]==tmpTreeItems[j].getAttribute('IDitem'))
							{
								newNode.view.toggleSelect(j)
								//log('selecting item on row '+j+' which has IDitem value of '+tmpTreeItems[j].getAttribute('IDitem'))
							}
						}
					}
				}
				break
			
			case 'listbox':
				//check listitems
				break
			
			case 'menulist':
				if(arr_globalRequestPoll[IDrequest].setup.selectedItems)
				{
					if(arr_globalRequestPoll[IDrequest].setup.selectedItems.length)
					{
						var i;
						for(i=0;i<arr_globalRequestPoll[IDrequest].setup.selectedItems.length;i++)
						{
							//log('checking list for value of '+arr_globalRequestPoll[IDrequest].setup.selectedItems[i])
							var tmpMenuItems=newNode.getElementsByTagName('menuitem')
							for(var j=0;j<tmpMenuItems.length;j++)
							{
								//log('list item '+j+' has value of '+tmpMenuItems[j].getAttribute('IDitem'))
								if(arr_globalRequestPoll[IDrequest].setup.selectedItems[i]==tmpMenuItems[j].getAttribute('IDitem'))
								{
									//log('newNode '+newNode.nodeName)
									//log('setting selection to '+j)
									newNode.selectedIndex=j;
									break
								}
							}
						}
					}
				}
				break
		}
		
		if(newNode.getAttribute('IDtoolbar'))
		{
			//node has a toolbar associated, updating
			var tmpToolbar = document.getElementById(newNode.getAttribute('IDtoolbar'))
			if(tmpToolbar)
			{
				if(e4x.setup)
				{
					if(e4x.setup.page)
					{
						var tmpPageCurrent = ui.toolbox.anonymous.getElementByAttribute(tmpToolbar, 'IDanon', "pageCurrent", null)
						if(tmpPageCurrent)
						{
							tmpPageCurrent.value=e4x.setup.page.@current
						}
						
						var tmpPagePrevious = ui.toolbox.anonymous.getElementByAttribute(tmpToolbar, 'IDanon', "pagePrevious", null)
						if(tmpPagePrevious)
						{
							//alert('prev '+e4x.setup.page.@previous)
							if(e4x.setup.page.@previous>0)
							{
								tmpPagePrevious.removeAttribute('disabled')
							}
							else
							{
								tmpPagePrevious.setAttribute('disabled', "true")
							}
						}
						
						var tmpPageNext = ui.toolbox.anonymous.getElementByAttribute(tmpToolbar, 'IDanon', "pageNext", null)
						if (tmpPageNext)
						{
							//alert('next '+e4x.setup.page.@next)
							if(e4x.setup.page.@next>0)
							{
								tmpPageNext.removeAttribute('disabled')
							}
							else
							{
								tmpPageNext.setAttribute('disabled', "true")
							}
						}
					}
				}
			}
		}
	}
	
}


App.prototype.detail = function (e4x, IDrequest)
{
	this.setup.e4x = e4x
	ui[this.id].detail(e4x, IDrequest)

}


App.prototype.edit = function(e4x, IDrequest)
{
	if(arr_globalRequestPoll[IDrequest].setup.closeOnSave!=0)
	{
		arr_globalRequestPoll[IDrequest].setup.closeOnSave=1
	}
	
	if(e4x.result==1)
	{
		if(arr_globalRequestPoll[IDrequest].setup.closeOnSave)
		{
			ui.toolbox.tab.close(arr_globalRequestPoll[IDrequest].setup.sourceXulElement)
		}
		else
		{
			for each (var tmpVal in e4x.*)
			{
				var tmpXulNode = ui.toolbox.anonymous.getElementByAttribute(arr_globalRequestPoll[IDrequest].setup.sourceXulElement, 'IDdata', tmpVal.name(), null)
					
				if(tmpXulNode)
				{
					if(tmpXulNode.nodeName)
					{
						if(tmpXulNode.nodeName=='textbox')
						{
							tmpXulNode.setAttribute('value', tmpVal)
						}
						if(tmpXulNode.nodeName=='menulist')
						{
							tmpXulNode.setAttribute('value', tmpVal)
						}
					}
				}
			}
		}
		
	}
	else
	{
		alert("the save did not succeeed! :( at least i'll have your editor left open, just in case you wanted to save the text somewhere :)")
	}
}

