// *********************************************
// Events
// *********************************************

var Event = {

	updater : {
		check : function(){
			var rdfService = Components.classes["@mozilla.org/rdf/rdf-service;1"].
				getService(Components.interfaces.nsIRDFService)

			var karen = rdfService.GetResource("http://www.webcom.sk/update.rdf")

			alert(karen.Value)
		},

		execute : function(){

		}
	},

	config : {
		init : function() {
			cs_Core.config.loggateway =  document.getElementById("log")

			cs_Core.locale.get();

	  		Event.config.preferences.get()
		},

		preferences : {
			get: function (){
		  		var prefs = Components.classes["@mozilla.org/preferences-service;1"]
								.getService(Components.interfaces.nsIPrefBranch);

				cs_Core.config.host = prefs.getCharPref("extensions.cycloneCMS.config.host")
				
				if(!cs_Core.config.host.toString().match(/http/)){
					cs_Core.config.host = "http://" + cs_Core.config.host
				}
				
				cs_Core.usrm.login  = prefs.getCharPref("extensions.cycloneCMS.usrm.login")
				//cs_Core.usrm.pass  = prefs.getCharPref("extensions.cycloneCMS.usrm.pass")
			},
			
			getPref: function (pref){
				var var_dataBranch = Components.classes["@mozilla.org/preferences-service;1"] 
				.getService(Components.interfaces.nsIPrefService) .getBranch('extensions.cycloneCMS.')
				
				try{
					var hosts = var_dataBranch.getCharPref("preferences.MRUhost")
				}catch(e){
					var_dataBranch.setCharPref("preferences.MRUhost","")
				}
				
				try{
					var hosts = var_dataBranch.getCharPref("preferences.updated")
				}catch(e){
					var_dataBranch.setCharPref("preferences.updated","true")
				}

				return var_dataBranch.getCharPref(pref)
			},

			set: function (prefVars){
				var var_dataBranch = Components.classes["@mozilla.org/preferences-service;1"] 
					.getService(Components.interfaces.nsIPrefService) .getBranch('extensions.cycloneCMS.')


				for (var prefVar in prefVars){
					if(prefVar=='host'){
					var_dataBranch.setCharPref("config.host", prefVars[prefVar])
					cs_Core.config.host = var_dataBranch.getCharPref("config.host")
					}
					else if(prefVar=='login'){
					var_dataBranch.setCharPref("usrm.login", prefVars[prefVar])
					cs_Core.usrm.login  = var_dataBranch.getCharPref("usrm.login")
					}
					else if(prefVar=='pass'){
					//	prefs.setCharPref("extensions.cycloneCMS.usrm.pass", prefVars[prefVar])
					//	cs_Core.usrm.pass  = prefs.getCharPref("extensions.cycloneCMS.usrm.pass")
						cs_Core.usrm.pass = prefVars[prefVar]
					}
					else if(prefVar=='updated'){
						var_dataBranch.setCharPref("preferences.updated", prefVars[prefVar])
					}
					else if(prefVar=='MRUhost'){
try{
						var hosts = var_dataBranch.getCharPref("preferences.MRUhost")
						
						if(hosts == ""){
							var_dataBranch.setCharPref("preferences.MRUhost", prefVars[prefVar])
							return
						}

						var hostfound
						var arr_hosts=hosts.split(';')
						for(var i=0;i<arr_hosts.length;i++){
							if(arr_hosts[i]==prefVars[prefVar]){
								hostfound=true
							}
						}
						if(!hostfound){
							arr_hosts.push(prefVars[prefVar])
						}
						hosts=arr_hosts.join(';')

						var_dataBranch.setCharPref("preferences.MRUhost", hosts)
}catch(e){alert(e)}
					}
					else{
						var_dataBranch.setCharPref(prefVar, prefVars[prefVar])
					}
				}
			}
		},
		
		lng :
		{
			acceptedLngs : [],
			get: function()
			{
				Handler.fnc_create
				(
					{},
					"",
					{
						type: "conf_list",
						version: ui.uipackage.getInstalledVersion()
					}
				)
			}
		},
		
		profile:
		{
			get: function()
			{
				Handler.fnc_create
				(
					{},
					"",
					{
						type: "xml_profile_get",
						version: ui.uipackage.getInstalledVersion()
					}
				)
			}
		}
	},

	usrm :
	{
		login: function()
		{
			if(!cs_Core.config.host)
			{
				alert('You did not enter your host name!')
			}
			if(!cs_Core.usrm.login)
			{
				alert('You did not enter your login name!')
			}
			if(!cs_Core.usrm.pass)
			{
				alert('You did not enter your password!')
			}
			
			// ak uzivatel nezada http, tak ho tam doplnime, inak to blbo, vyhadzovalo vynimku, ze nevedel otvorit post stream
			if(!cs_Core.config.host.toString().match(/http/))
			{
				cs_Core.config.host = "http://" + cs_Core.config.host
			}
			
			Handler.fnc_create(
				{},
				"",
				{
					type: "login",
					login: cs_Core.usrm.login,
					pass: cs_Core.usrm.pass,
					version: ui.uipackage.getInstalledVersion()
				}
			)
		},
		
		logout: function()
		{
			Handler.fnc_create(
				{},
				"",
				{type: "logout"}
			)
		}
	},
	
	Apps: Apps
}
