// *********************************************
// Macros
// *********************************************
function log(message){
	cs_Core.log.append(message)
}

function feed(gateway,xul,element){
	var parser = new DOMParser()

	var tmpXulObject=parser.parseFromString(xul,"text/xml")

	var tmpXulObjectReplacer=tmpXulObject.documentElement.getElementsByTagName(element)[0]

	var tmpXulObjectToReplace = gateway.getElementsByTagName(element)[0];

	if(tmpXulObject)
	{
		var listNode = gateway.replaceChild(tmpXulObjectReplacer, tmpXulObjectToReplace);
	}
	else
	{
		var listNode = gateway.appendChild( document.createElement(element));
	}
}

function base64Encode(str)
{
	var charBase64 = new Array(
		'A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P',
		'Q','R','S','T','U','V','W','X','Y','Z','a','b','c','d','e','f',
		'g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v',
		'w','x','y','z','0','1','2','3','4','5','6','7','8','9','+','/'
	);

	var out = "";
	var chr1, chr2, chr3;
	var enc1, enc2, enc3, enc4;
	var i = 0;

	var len = str.length;

	do
	{
		chr1 = str.charCodeAt(i++);
		chr2 = str.charCodeAt(i++);
		chr3 = str.charCodeAt(i++);

		//enc1 = (chr1 & 0xFC) >> 2;
		enc1 = chr1 >> 2;
		enc2 = ((chr1 & 0x03) << 4) | (chr2 >> 4);
		enc3 = ((chr2 & 0x0F) << 2) | (chr3 >> 6);
		enc4 = chr3 & 0x3F;

		out += charBase64[enc1] + charBase64[enc2];

		if (isNaN(chr2))
  		{
			out += '==';
		}
  		else if (isNaN(chr3))
  		{
			out += charBase64[enc3] + '=';
		}
		else
		{
			out += charBase64[enc3] + charBase64[enc4];
		}
	}
	while (i < len);

	return out;
}

